#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin>>t;

    while(t--)
    {
        int n,m,s;
        cin>>n>>m>>s;

        vector<int> korlat(s);

        for(int i=0; i<s; i++)
        {
            cin>>korlat[i];
        }

        vector<vector<int>> el(m);
        vector<pair<int,int>> ki;

        int egyik, masik;

        for(int i=0; i<m; i++)
        {
            cin>>egyik>>masik;
            el[egyik].push_back(masik);
            el[masik].push_back(egyik);
            ki.push_back(make_pair(egyik,masik));
        }

        bool lehet=true;

        for(int i=0; i<s; i++)
        {
            if(el[korlat[i]].size()>1)
            {
                lehet=false;
                break;
            }
        }

        if(lehet)
        {
            for(auto it:ki)
            {
                cout<<it.first<<" "<<it.second<<endl;
            }
        }
        else
        {
            cout<<-1<<endl;
        }



    }
    return 0;
}